//+------------------------------------------------------------------+
//|                                        Linea Apertura Diaria.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property version   "1.00"
#property strict
#property indicator_chart_window


#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 White
#property indicator_style1 2
#property indicator_width1 1


extern int TimeZoneOfData = 0;
 

double TodayOpenBuffer[];

//**************************************************************************************************************************

int init()
{
	SetIndexStyle(0,DRAW_LINE);
	SetIndexBuffer(0,TodayOpenBuffer);
	SetIndexLabel(0,"Open");
	SetIndexEmptyValue(0,0.0);
	return(0);
}

//**************************************************************************************************************************

int deinit()
{
	return(0);
}

//**************************************************************************************************************************

int start()
{
   int lastbar;
   int counted_bars= IndicatorCounted();
   
   if (counted_bars>0) counted_bars--;
   lastbar = Bars-counted_bars;	
   DailyOpen(0,lastbar);
   
   return (0);
}

//**************************************************************************************************************************

int DailyOpen(int offset, int lastbar)
{
   int shift;
   int tzdiffsec= TimeZoneOfData * 3600;
   int barsper30= PERIOD_M30/Period();
   bool ShowDailyOpenLevel= True;
   	 
//         int limit = MathMin(Bars-counted_bars,Bars-1);
//   lastbar= MathMin(Bars-20*barsper30-1, lastbar);

   lastbar= MathMin(Bars-20*barsper30-1, Bars-1);
   
	for(shift=lastbar;shift>=offset;shift--)
	{
	  TodayOpenBuffer[shift]= 0;
     if (ShowDailyOpenLevel)
     {
      if(TimeDay(Time[shift]-tzdiffsec) != TimeDay(Time[shift+1]-tzdiffsec))
      {    
         TodayOpenBuffer[shift]= Open[shift];         
         TodayOpenBuffer[shift+1]= 0;                                                           
      }
      else
      {
         TodayOpenBuffer[shift]= TodayOpenBuffer[shift+1];
      }
	  }
   }
   return(0);
}